using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using System.Text;
using System.IO;
using System.Threading ;

namespace TELNETCLIENT
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		Char IAC		= Convert.ToChar(255);
		Char DO	= Convert.ToChar(253);
		Char DONT		= Convert.ToChar(254);
		Char WILL		= Convert.ToChar(251);
		Char WONT		= Convert.ToChar(252);
		Char SB			= Convert.ToChar(250);
		Char SE			= Convert.ToChar(240);
		const	Char IS			= '0';
		const	Char SEND		= '1';
		const	Char INFO		= '2';
		const	Char VAR		= '0';
		const	Char VALUE		= '1';
		const	Char ESC		= '2';
		const	Char USERVAR	= '3';
		string m_strResp;

		ArrayList  m_ListOptions = new ArrayList();
		ArrayList  m_DATA  = new ArrayList();
		IPEndPoint iep ;
		AsyncCallback callback ;
		
//		Form2 f2 = new Form2();		
		int XPOS = 0 ;
		int YPOS = 10 ;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private Thread t ;
		string address = "134.48.4.15";
		string global_string  ;
		//string address = "127.0.0.1";
		Socket s ;
		int port = 23 ;
		Byte[] readBytes;
		IAsyncResult ar1;
		Byte[] m_byBuff = new Byte[32767];
		string m_strNormalText="";
		string m_strLine ;
		string strToSend = "";
		string enterstring ;
		private System.Windows.Forms.TextBox textBox1;
		private string command="";
		public Form1()
		{
//			f2.Show() ;
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.SuspendLayout();
			// 
			// textBox1
			// 
			this.textBox1.AcceptsReturn = true;
			this.textBox1.AcceptsTab = true;
			this.textBox1.BackColor = System.Drawing.Color.White;
			this.textBox1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.textBox1.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox1.ImeMode = System.Windows.Forms.ImeMode.On;
			this.textBox1.Multiline = true;
			this.textBox1.Name = "textBox1";
			this.textBox1.ReadOnly = true;
			this.textBox1.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.textBox1.Size = new System.Drawing.Size(712, 381);
			this.textBox1.TabIndex = 0;
			this.textBox1.Text = "";
			this.textBox1.KeyDown += new System.Windows.Forms.KeyEventHandler(this.textBox1_KeyDown);
			this.textBox1.Resize += new System.EventHandler(this.textBox1_Resize);
			this.textBox1.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.textBox1_KeyPress);
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(8, 15);
			this.ClientSize = new System.Drawing.Size(712, 381);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.textBox1});
			this.Font = new System.Drawing.Font("Courier New", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Telnet";
			this.KeyDown += new System.Windows.Forms.KeyEventHandler(this.Form1_KeyDown);
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.Form1_Paint);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			///////////////////////////////////////////////////////////////////////////////
			///////////////////////////////////////////////////////////////////////////////
			///////////////////////////////////////////////////////////////////////////////
			///////////////////////////////////////////////////////////////////////////////
			///////////////////////////////////////////////////////////////////////////////
			///////////////////////////////////////////////////////////////////////////////
			///////////////////////////////////////////////////////////////////////////////
			///////////////////////////////////////////////////////////////////////////////
			textBox1.SelectionLength= 0;
			
			try
			{
				s = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
				iep = new IPEndPoint(IPAddress.Parse(address) , port);
				s.Blocking = false ;
				callback = new AsyncCallback(SMK);
				s.BeginConnect(iep , callback , s ) ;
		
			}
			catch(Exception eeeee )
			{
				MessageBox.Show(eeeee.Message , "APPLICATION ERROR" );
				Application.Exit();
			}
		}

		public void SMK( IAsyncResult ar )
		{
			try
			{
				Socket sock1 = (Socket)ar.AsyncState;
				if ( sock1.Connected ) 
				{	
					AsyncCallback recieveData = new AsyncCallback( OnRecievedData );
					sock1.BeginReceive( m_byBuff, 0, m_byBuff.Length, SocketFlags.Partial, recieveData , sock1 );
				}
			}
			catch( Exception ex )
			{
				MessageBox.Show( this, ex.Message, "Setup Recieve Callback failed!" );
			}
		}

		
		public void OnRecievedData( IAsyncResult ar )
		{
			// Socket was the passed in object
			Socket sock = (Socket)ar.AsyncState;

			// Check if we got any data
			try
			{
				int nBytesRec = sock.EndReceive( ar );
				if( nBytesRec > 0 )
				{
					m_strLine="";
					string sRecieved = Encoding.ASCII.GetString( m_byBuff, 0, nBytesRec );
					int ndx =0;
					GetLine( m_byBuff , nBytesRec , ndx );
					Byte[] mToProcess = new Byte[nBytesRec];
					for ( int i=0; i < nBytesRec ; i++)
						mToProcess[i] = Convert.ToByte(m_strLine[i]);;
					string mOutText = ProcessOptions(mToProcess);
					textBox1.Text += m_strNormalText;
					ParseMessageForSpecialKeys(m_strNormalText);
					int len = textBox1.Text.Length;
					if ( len > textBox1.Height + textBox1.Width ) 
						textBox1.Text = textBox1.Text.Substring(textBox1.Height + textBox1.Width);
					textBox1.Select(textBox1.Text.Length,0);
				}
				else
				{
					// If no data was recieved then the connection is probably dead
					Console.WriteLine( "Client {0}, disconnected", sock.RemoteEndPoint );
					sock.Shutdown( SocketShutdown.Both );
					sock.Close();
				}
			}
			catch( Exception ex )
			{
				MessageBox.Show( this, ex.Message, "Unusual error druing Recieve!" );
			}
		}

		private void Response()
		{
			string serverMessage="";
			int sizeReceived=0;
			readBytes = new Byte[10242];
			sizeReceived  = s.Receive(readBytes , readBytes.Length , SocketFlags.None);
			serverMessage  = Encoding.ASCII.GetString(readBytes, 0, sizeReceived);
			UpdateText(serverMessage);
			ProcessOptions(readBytes);
			Response();
		}

		public void UpdateText(string str)
		{
			try
			{
				//				textBox1.Text = textBox1.Text + str ;
				//				textBox1.SelectionStart= textBox1.Text.Length;
			}
			catch(Exception es)
			{
				MessageBox.Show("ERROR WHEN UPDATING TEXT");
			}
		}

		private string ProcessOptions(byte[] m_strLineToProcess)
		{
			string m_DISPLAYTEXT="";
			char ch;
			int ndx=0;
			int ldx;
			bool bScanDone = false;
			string m_strTemp="" ;
			string m_strOption="";

			for ( int i=0; i < m_strLineToProcess.Length ; i++)
			{
				Char ss = Convert.ToChar(m_strLineToProcess[i]);
				m_strTemp = m_strTemp + Convert.ToString(ss);
			}
			//				m_strTemp = Encoding.ASCII.GetString(m_strLine);

			while(bScanDone != true )
			{
				int lensmk = m_strTemp.Length;
				ndx = m_strTemp.IndexOf(Convert.ToString(IAC));
				if ( ndx > lensmk )
					ndx = m_strTemp.Length;

				if(ndx != -1)
				{
					m_DISPLAYTEXT+= m_strTemp.Substring(0,ndx);
					ch = m_strTemp[ndx + 1];
					if ( ch == DO || ch == DONT || ch == WILL || ch == WONT ) 
					{
						m_strOption		= m_strTemp.Substring(ndx, 3);
						string txt		= m_strTemp.Substring(ndx + 3);
						m_DISPLAYTEXT+= m_strTemp.Substring(0,ndx);
						m_ListOptions.Add(m_strOption);
						m_strTemp		= txt ;
					}
					else
						if ( ch == IAC)
					{
						m_DISPLAYTEXT= m_strTemp.Substring(0,ndx);
						m_strTemp		= m_strTemp.Substring(ndx + 1);
					}
					else
						if ( ch == SB ) 
					{
						m_DISPLAYTEXT= m_strTemp.Substring(0,ndx);
						ldx = m_strTemp.IndexOf(Convert.ToString(SE));
						m_strOption		= m_strTemp.Substring(ndx, ldx);
						m_ListOptions.Add(m_strOption);
						m_strTemp			= m_strTemp.Substring(ldx);
					}
				}
				else
				{
					m_DISPLAYTEXT = m_DISPLAYTEXT + m_strTemp;
					bScanDone = true ;
				}
			} 

			m_strNormalText = m_DISPLAYTEXT; 
			
			RespondToOptions();
			
			return m_DISPLAYTEXT;
		}
	
		void DispatchMessage(string strText)
		{
			Byte[] smk = new Byte[strText.Length];
			for ( int i=0; i < strText.Length ; i++)
			{
				Byte ss = Convert.ToByte(strText[i]);
				smk[i] = ss ;
			}

			//strText += "\r\n" ; 
			IAsyncResult ar2 = s.BeginSend(smk , 0 , smk.Length , SocketFlags.None , callback , s );
			s.EndSend(ar2);
			//			s.Send(Encoding.ASCII.GetBytes(strText), strText.Length, 0);
		}

		void RespondToOptions()
		{
			string strOption;
			for ( int i=0; i < m_ListOptions.Count; i++)
			{
				strOption = (string)m_ListOptions[i];
				ArrangeReply(strOption);
			}
			DispatchMessage(m_strResp);
			m_strResp ="";
			m_ListOptions.Clear();
			m_strLine= "" ;
		}
	
		void ArrangeReply(string strOption)
		{
			Char Verb;
			Char Option;
			Char Modifier;
			Char ch;
			bool bDefined = false;

			if(strOption.Length  < 3) return;

			Verb = strOption[1];
			Option = strOption[2];

			if ( Option == 1 || Option == 3 ) 
			{
				//				case 1:	// Echo
				//				case 3: // Suppress Go-Ahead
				bDefined = true;
				//					break;
			}

			m_strResp += IAC;

			if(bDefined == true )
			{
				if ( Verb == DO ) 
				{
					//					case DO:
					ch = WILL;
					m_strResp += ch;
					m_strResp += Option;
					//						break;
				}
				if ( Verb == DONT ) 
				{
					ch = WONT;
					m_strResp += ch;
					m_strResp += Option;
					//		break;
				}
				if ( Verb == WILL ) 
				{
					ch = DO;
					m_strResp += ch;
					m_strResp += Option;
					//break;
				}
				if ( Verb == WONT)
				{
					ch = DONT;
					m_strResp += ch;
					m_strResp += Option;
					//	break;
				}
				if ( Verb == SB)
				{
					Modifier = strOption[3];
					if(Modifier == SEND)
					{
						ch = SB;
						m_strResp += ch;
						m_strResp += Option;
						m_strResp += IS;
						m_strResp += IAC;
						m_strResp += SE;
					}
					//						break;
				}
			}
			else
			{
				//				switch(Verb)
				//				{
				if ( Verb == DO ) 
				{
					ch = WONT;
					m_strResp += ch;
					m_strResp += Option;
					//	break;
				}
				if ( Verb == DONT)
				{
					ch = WONT;
					m_strResp += ch;
					m_strResp += Option;
					//	break;
				}
				if ( Verb == WILL)
				{
					ch = DONT;
					m_strResp += ch;
					m_strResp += Option;
					//	break;
				}
				if ( Verb == WONT)
				{
					ch = DONT;
					m_strResp += ch;
					m_strResp += Option;
					//		break;
				}
			}
		}

		//		private void button1_Click(object sender, System.EventArgs e)
		//		{
		//			if ( textBox2.Text == "" ) 
		//				textBox2.Text = "\r\n" ;
		//			else
		//				textBox2.Text = textBox2.Text + "\r\n" ;
		//
		//			Byte[] bs = Encoding.ASCII.GetBytes(textBox2.Text);
		//			IAsyncResult ar3 = s.BeginSend(bs, 0 , bs.Length , SocketFlags.None ,  callback , s );
		//			s.EndSend(ar3);
		//			textBox2.Text="";
		//		}
	
	
		bool GetLine( Byte[] bytes, int nBytes, int ndx )
		{
			bool bLine = false;
			try
			{
				while ( bLine == false && ndx < nBytes )
				{
					Char ch = Convert.ToChar(bytes[ndx]);
			
					switch( ch )
					{
						case '\r': // ignore
							m_strLine += "\r\n"; //"CR";
							break;
						case '\n': // end-of-line
							//			m_strLine += '\n'; //"LF";
							//			bLine = TRUE;
							break;
						default:   // other....
							m_strLine += ch;
							break;
					} 
					ndx ++;
					if (ndx == nBytes)
					{
						bLine = true;
					}
				}
			}
			catch(Exception eg)
			{
				MessageBox.Show("ERROR IN GETLINE");
			}
			return bLine;
		}

		private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
		}

		private void Form1_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
		}

		private void textBox1_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if ( e.KeyChar == 13 ) 
			{
				DispatchMessage("\r\n");
				command="";
			}
			else
			{
				string str = e.KeyChar.ToString();
				DispatchMessage(str);
			}
		}
	}
}